︠6e2bd8cb-cf8a-47cb-886b-46b5b35ce42f︠
#Schroeder Thermal Physics problem 3.17
#Properties of a two-state paramagnet with 100 dipoles in magnetic field B.
#Nup is the number of dipoles pointing up.
︡5c419274-29b6-46a1-969b-7d699f249af4︡︡
︠ff1d3b12-b5e6-48fc-baa5-ea419c66c501︠
N = 100
U = [] #list of values of U/mu/B
for Nup in range(N+1):
    U.append([Nup, N - 2*Nup])
from sage.plot.scatter_plot import ScatterPlot
scatter_plot(U, marker='s')
︡261c51ac-c479-442d-8e8e-cd63953f3440︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠382554a2-223b-432c-8dc4-be7cfa34d538︠
range(0,N/2-1)+[N/2]+range(N/2+2,N+1)
︡6a9bb353-7eb0-44ee-b24a-70dcd497e772︡{"stdout": "[0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 50, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100]"}︡
︠0abe7cec-f18f-4dbc-8413-7735162cefbf︠
M = [] #list overall Magnetism values M/N/mu
for Nup in range(N+1):
    M.append([Nup, 2*Nup/N - 1])
scatter_plot(M, marker='s')
︡c18e10ae-c8e2-43dc-951d-fee5278bf6fc︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠fd0ef68b-0737-4117-8ed9-0dfe8165d1fb︠
Omega = [] #list values of the multiplicity
for Nup in range(N+1):
    Omega.append([Nup, binomial(N,Nup)])
scatter_plot(Omega, marker='s')
︡e9f5bb1b-cbbf-4008-b042-f61368984b58︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠2f2293b3-2542-433f-ad76-e01b0dc25d73︠
S = [] #list of values of the entropy S/k
for Nup in range(N+1):
    S.append([Nup, ln(binomial(N,Nup))])
scatter_plot(S, marker='s')
︡2a5917eb-06dd-43b8-9106-ac48add1a6d0︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠4edb292c-11b2-4ec0-8309-fdd80ed125ef︠
T = [] #list values of Temperature k*T/mu/B
def Temp(Nup):
    DU = (N-2*(Nup+1)) - (N-2*(Nup-1)) #difference in U between next and previous Nup value
    DS = ln(binomial(N,Nup+1)) - ln(binomial(N,Nup-1))
    return DU/DS #DU/DS approximates the derivative dU/dS = T
for Nup in range(N+1):
    if Nup!=50:  #skip trouble spot (division by zero)
        T.append([Nup, Temp(Nup)]) 
scatter_plot(T, marker='s')
︡83298c20-ef79-4bb7-898a-de7ae07cf75e︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠f71133e4-4e63-4a29-8baa-37a3781d8a2e︠
#looks like 1/x, so try taking the reciprocal of previous plot's y-axis
#1/T vs Nup
oneOverT = [] #start list values of Temperature 1/(k*T/mu/B)
for Nup in range(1,N/2)+range(N/2+1,N):
    oneOverT.append([Nup, 1/Temp(Nup)]) 
scatter_plot(oneOverT, marker='s')
︡1e6005b5-56e7-44d1-afa5-c221bda75e56︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠1affd6a4-073e-44d9-b734-cdc4951744f3︠
range(1,N/2-1)+[N/2]+range(N/2+2,N)
︡a71645b1-0973-416a-8704-81e6a9134aff︡{"stdout": "[1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 50, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99]"}︡
︠a59ab785-1483-43b0-bde6-2d607f7de6ad︠
C = [] #list values of Heat Capacity C/N/k = d(U/mu/B)/d(k*T/u/B)/N
for Nup in range(1,N/2-1)+[N/2]+range(N/2+2,N):  #skip trouble spots
    DU = (N-2*(Nup+1)) - (N-2*(Nup-1))
    DT = Temp(Nup+1) - Temp(Nup-1)
    C.append([Nup, DU/DT]) #DU/DT approximates the derivative dU/dT
scatter_plot(C, marker='s')
︡ae338977-0421-4947-86c4-db5044032677︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠290526eb-34d4-46cb-804c-f313439f050d︠
range(1,N/2-1)+range(N/2+2,N)
︡cf7fb7ed-fc53-4284-a582-8fdd6e310ec8︡{"stdout": "[1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99]"}︡
︠4b7bad3b-c197-4c53-94fd-ca1de2ef3a30︠
#Heat Capacity as a function of Temperature
CT = []
for Nup in range(1,N/2-1)+range(N/2+2,N):  #avoid dividing by zero
    DU = (N-2*(Nup+1)) - (N-2*(Nup-1))
    DT = Temp(Nup+1) - Temp(Nup-1)
    CT.append((n(Temp(Nup), digits=4), n(DU/DT, digits=4))) #DU/DT approximates the derivative dU/dT
scatter_plot(CT, marker='s', aspect_ratio='.5')
︡dc0e9fd8-e8ca-4320-9154-489271ad8689︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
